/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             *
 *                                                                         *
 ***************************************************************************/

#ifndef KCDEMUDEVICEMENU
#define KCDEMUDEVICEMENU

#include <stdlib.h>

#include <qfile.h>
#include <qregexp.h>

#include <kprocess.h>
#include <kfiledialog.h>
#include <kmessagebox.h>
#include <kpopupmenu.h>

#include "KCDemuProcess.h"

class KCDemuDeviceMenu : public KPopupMenu {
	Q_OBJECT

	public:
//		KCDemuDeviceMenu(QWidget* parent = 0, const char* name = 0);
		KCDemuDeviceMenu(QWidget* parent = 0, const char* name = 0, int device = 0);
		~KCDemuDeviceMenu();

		void checkStatus();		//Reads status from /proc/cdemu

	public slots:
		void openCDImage();					//Opens a new CD Image
		void unmountCDImage();					//Unmounts currently mounted CD-Image
		void setAsCdrom();					//Sets this device as /dev/cdrom (saves original one)

	signals:
		void CDImageOpened( int devNum, bool bMounted );	//Emitted when a new image was opened

	private:
		QString currentCDImage;		//Name of current CD Image mounted

		int fileNameEntryID;		//ID of File-name / mount entry
		int unmountEntryID;		//ID of "Unmount" entry
		int setAsDefaultID;		//ID of "set as default" entry

		int deviceNum;			//Device this menu is responsible for

};

#endif
