/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             *
 *                                                                         *
 ***************************************************************************/

#include "KCDemuNumDevMenu.h"
#include "KCDemuNumDevMenu.moc"

KCDemuNumDevMenu::KCDemuNumDevMenu(QWidget* parent, const char* name) {
	int itemID = 0;

	itemID = insertItem( "1", this, SLOT( setNumDevices( int ) ) );
	setItemParameter( itemID, 1 );
	itemID = insertItem( "2", this, SLOT( setNumDevices( int ) ) );
	setItemParameter( itemID, 2 );
	itemID = insertItem( "3", this, SLOT( setNumDevices( int ) ) );
	setItemParameter( itemID, 3 );
	itemID = insertItem( "4", this, SLOT( setNumDevices( int ) ) );
	setItemParameter( itemID, 4 );
}

KCDemuNumDevMenu::~KCDemuNumDevMenu() {
}

//SLOT for setting number of devices (need write permission for /dev/cdemu/)
void KCDemuNumDevMenu::setNumDevices( int numDev ) {
	//Just for extra security
	if( numDev <= 0 ) {
		return;
	}

	for(int i = 0; i < numDev; i++) {
		QString device("/dev/cdemu/");
		device.append( QString::number( numDev ) );

		KCDemuProcess *mknodCommand = new KCDemuProcess();
		*mknodCommand << "mkdnod";
		*mknodCommand << device << "b" << "62" << QString::number( numDev );
		mknodCommand->start();
	}
}
