/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             *
 *                                                                         *
 ***************************************************************************/

#include "KCDemuProcess.h"
#include "KCDemuProcess.moc"

KCDemuProcess::KCDemuProcess() {
	QObject::connect( this, SIGNAL( receivedStdout (KProcess *, char *, int) ), this, SLOT( gotOutput( KProcess *, char *, int ) ) );
	QObject::connect( this, SIGNAL( receivedStderr (KProcess *, char *, int) ), this, SLOT( gotOutput( KProcess *, char *, int ) ) );

	this->bGotError = false;
}

KCDemuProcess::~KCDemuProcess() {
}

bool KCDemuProcess::gotError() {
	return this->bGotError;
}

void KCDemuProcess::gotOutput( KProcess *proc, char *buffer, int buflen ) {
	buffer[buflen] = '\0';

	this->bGotError = true;

	QString message( "The following error occured:\n" );
	message.append( buffer );

	KMessageBox::error( 0, message, "Process error" );
}
