/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             *
 *                                                                         *
 ***************************************************************************/

#ifndef KCDEMUSYSTEMTRAY
#define KCDEMUSYSTEMTRAY

#include "KCDemuSettingsMenu.h"
#include "KCDemuDeviceMenu.h"

#include <stdio.h>

#include <qpixmap.h>

#include <kapplication.h>
#include <ksystemtray.h>
#include <kpopupmenu.h>
#include <kiconloader.h>

struct KCDemuDeviceMenuStruct {
	~KCDemuDeviceMenuStruct() { delete pNext; }

	KCDemuDeviceMenu *deviceMenu;
	int deviceMenuID;
	int numDev;

	KCDemuDeviceMenuStruct *pNext;
};

class KCDemuSystemTray : public KSystemTray {
	Q_OBJECT

	public:
		KCDemuSystemTray(QWidget* parent = 0,  const char* name = 0);
		~KCDemuSystemTray();

	public slots:
		void changeState ( int devNum, bool bMounted );
		void unmountAllImages();

	private:
		void mousePressEvent (QMouseEvent *e);

		int setIcon (QPixmap newIcon);
		int createMenus ();

		int createDeviceMenu( int numDev );

		QPixmap mountedIcon;
		QPixmap unmountedIcon;
		QPopupMenu *trayLeftMenu;
		QPopupMenu *trayRightMenu;

		KCDemuSettingsMenu *settingsMenu;
		KCDemuDeviceMenuStruct *pFirstDeviceMenu;
};

#endif
